config() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
    # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

preserve_perms() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  if [ -e $OLD ]; then
    cp -a $OLD ${NEW}.incoming
    cat $NEW > ${NEW}.incoming
    mv ${NEW}.incoming $NEW
  fi
  config $NEW
}

preserve_perms etc/rc.d/rc.hiawatha.new
preserve_perms etc/hiawatha/index.xslt.new
preserve_perms etc/hiawatha/hiawatha.conf.new
preserve_perms etc/hiawatha/error.xslt.new
preserve_perms etc/hiawatha/cgi-wrapper.conf.new
preserve_perms etc/hiawatha/mimetype.conf.new
( cd usr/lib64/hiawatha ; rm -rf libmbedtls.so )
( cd usr/lib64/hiawatha ; ln -sf libmbedtls.so.12 libmbedtls.so )
( cd usr/lib64/hiawatha ; rm -rf libmbedcrypto.so.3 )
( cd usr/lib64/hiawatha ; ln -sf libmbedcrypto.so.2.16.0 libmbedcrypto.so.3 )
( cd usr/lib64/hiawatha ; rm -rf libmbedx509.so )
( cd usr/lib64/hiawatha ; ln -sf libmbedx509.so.0 libmbedx509.so )
( cd usr/lib64/hiawatha ; rm -rf libmbedcrypto.so )
( cd usr/lib64/hiawatha ; ln -sf libmbedcrypto.so.3 libmbedcrypto.so )
( cd usr/lib64/hiawatha ; rm -rf libmbedx509.so.0 )
( cd usr/lib64/hiawatha ; ln -sf libmbedx509.so.2.16.0 libmbedx509.so.0 )
( cd usr/lib64/hiawatha ; rm -rf libmbedtls.so.12 )
( cd usr/lib64/hiawatha ; ln -sf libmbedtls.so.2.16.0 libmbedtls.so.12 )
